#include "snake.h"
#include <stdlib.h>

/* prototypes */
int arenaput(int y, int x, sprite *sp);
sprite *arenaget(int y, int x);
int arenalines(void);
int arenacols(void);
int arenainit(int cols, int lines);
void arenadraw(void);

/* private data */
static sprite **_arena;
static int _arenacols, _arenalines;
static int _arenainit=0;
 

int arenainit (int lines, int cols)
{
	if ( _arenainit ) /* already initialized */
	{
		fprintf(stderr, "Arena already initialized\n");
		return 0;
	}

	_arenainit=1;

	_arena=malloc(lines*cols*sizeof(sprite));
	if ( ! _arena ) /* out of virtual memory */
	{
		fprintf(stderr, "Out of virtual memory!\n");
		return 0;
	}

	_arenacols=cols;
	_arenalines=lines;

	return 1;
}

int arenalines()
{
	return _arenalines;
}

int arenacols()
{
	return _arenacols;
}

sprite *arenaget(int y, int x)
{
/*
	if ( y >= _arenalines || y < 0 ) return NULL;
	if ( x >= _arenacols  || x < 0 ) return NULL;
*/
	return _arena[y*_arenacols+x];
}

int arenaput(int y, int x, sprite *sp)
{
/*
	if ( y >= _arenalines || y < 0 ) return 0;
	if ( x >= _arenacols  || x < 0 ) return 0;
*/
	_arena[y*_arenacols+x] = sp;
	return 1;
}

void arenadraw()
{
	int y, x;
	sprite *sp;
	chtype look;

	for (y=0; y<_arenalines; y++ )
	{
		for (x=0; x<_arenacols; x++ )
		{
			sp = _arena[y*_arenacols+x];
			if ( sp ) switch (sp->type)
			{
				case SNAKE:
					look=((snakebody *)(sp))->self->look;
					break;
				case EXSNAKE:
					look='.';
					break;
				case FRUIT:
					look=((fruit *)(sp))->value;
					break;
				case WALL:
					look='#';
				default:
					look='?';
					break;
			}
			else look=' ';
			mvwaddch(arenawin,
				y+ARENA_Y_OFFSET,
				x+ARENA_X_OFFSET,
				look);
		}
	}
}



