#include "snake.h"
#include <errno.h>
#include <stdlib.h>	/* malloc */
#include <string.h>	/* strcat, ... */
#include <stdio.h>	/* fopen, fclose, ... */

/* external data */
extern char *rootdir;
extern FILE *conf;

/* external functions */
extern void finish (void);

/* private functions */
static char *get_config_path (void);

/* public_functions */
void open_config (void);
void close_config (void);

/* public data */
FILE *conf;

static char *get_config_path()
{
	char *confpath;

	confpath = malloc(strlen(rootdir)+strlen(SNAKE_CONFIG));
	if ( ! confpath ) {
		fprintf(stderr, "Out of virtual memor\n");
		finish();
	}

#ifdef DEBUG
	fprintf(stderr, "snake_config: rootdir before strcat is %s\n", rootdir);
	fprintf(stderr, "snake_config: confpath before strcat is %s\n", confpath);
#endif

	strcpy(confpath, rootdir);
	strcat(confpath, "/");
	strcat(confpath, SNAKE_CONFIG);

#ifdef DEBUG
	fprintf(stderr, "snake_config: rootdir after strcat is %s\n", rootdir);
	fprintf(stderr, "snake_config: confpath after strcat is %s\n", confpath);
#endif

	return confpath;
}

void open_config ()
{
	char *confpath;

	confpath = get_config_path();

	conf = fopen(confpath, "r");
	if ( !conf ) {
		fprintf(stderr, "error opening %s: %s\n",
			confpath, strerror(errno));
		finish();
	}

}

void close_config ()
{
	fclose(conf);
}
