#include "snake.h"

/* public data */
int typein;

/* extern data */
extern int delay;
extern snake *zoo[];

/* extern functions */
extern void reset_snake (snake *);
extern void show_menu (void);
extern void finish (void);
extern void lower_delay (void);
extern void higher_delay (void);
extern void finish (void);

/* parse user input */
int parse_input ()
{
	int i;

	/* get a character */
	typein=getch();

	/* return immediatly if no input is waiting */
	if ( typein == ERR ) return 1;

	switch (typein)
	{
		/* quit on 'q' */
		case 'q':
			finish();

		/* higher delay if '-' (lower speed)*/
		case '-':
			higher_delay();
			break;

		/* lower delay if '+' (higher speed)  */
		case '=':
		case '+':
			lower_delay();
			break;

		/* show menu */
		case 27:
			show_menu();
			break;

		/* nothing to do by default */
		default:
			/* reset a snake player */
			i = typein-48;
			if ( i >= 0 && i < MAXPLAYERS )
				if ( zoo[i] && zoo[i]->died )
					reset_snake(zoo[i]);
			break;
	}

	return 1;
}



