#include "snake.h"
#include <stdlib.h> /* free.. */

/* extern data */
extern snake *zoo[];

/* extern functions */
extern int rand_between ( int low, int high );

/* reset snake body */
void reset_snake (snake *s)
{
	snakebody *ptr, *oldptr;
	int x, y, dir;

	/* free space allocated for old body */
	ptr=s->head;
	while ( ptr != NULL )
	{
		oldptr=ptr;
		ptr=ptr->next;
		ARENAPUT(oldptr->cell.y, oldptr->cell.x, NULL);
		free(oldptr);
	}

	/* get a random position and direction for new body */
	do
	{
		x = rand_between (0, ARENA_WIDTH-1);
		y = rand_between (0, ARENA_HEIGHT-1);
	} while ( IS_SNAKE(ARENAGET(y,x)) || IS_FRUIT(ARENAGET(y,x)) );
	dir = rand_between (0, 3);

	/* create the new body */
	s->head = s->tail = (snakebody *) malloc(sizeof(snakebody));
	s->head->type = SNAKE;
	s->head->next = NULL;
	s->head->prev = NULL;
	s->head->cell.y = y;
	s->head->cell.x = x;

	/* assign initial length */
	s->length = 1;

	/* give it a life again (in case it was dead) */
	s->died = 0;

	/* reset the score (no Karma here...) */
	s->score = 0;
	
	/* welcome the reborn snake */
	message("welcome back snake %i !", s->playernum);
}

