#include "snake.h"

/* extern data */
extern snake *zoo[];
extern WINDOW *menuwin;

/* public functions */
void show_scores (void);
void make_scores (void);

/* public data */
WINDOW *scorewin;

/* private data */
int scorelines;
int scorecols;
int score_y_offset;
int score_x_offset;

void make_scores ()
{
	scorelines = LINES - (LINES/8);
	scorecols = COLS - (COLS/2);
	score_y_offset = (LINES - scorelines) / 2;
	score_x_offset = (COLS - scorecols) / 2;

	scorewin = newwin (scorelines, scorecols,
	                  score_y_offset, score_x_offset);

	wborder(scorewin, '|', '|', '-', '-', '*', '*', '*', '*');
	mvwaddstr(scorewin, 0, (scorecols/2)-5, "* SCORES *");
}

void show_scores ()
{
	int i;
	char str[256];

	for ( i=0; zoo[i]; i++ )
	{
		sprintf(str, "snake %c: %li", (char)zoo[i]->look, zoo[i]->score);
		mvwaddstr(scorewin, score_y_offset+1+i, 2, str);
	}

	/* refresh score window */
	touchwin(scorewin);
	wrefresh(scorewin);

	/* wait for keypress */
	while ( getch() == ERR );

	touchwin(arenawin);
	touchwin(menuwin);
	wrefresh(arenawin);
	wrefresh(menuwin);
}



